#ifndef EULER_ANGLE_WINDOW
#define EULER_ANGLE_WINDOW

#include <QWidget>
#include <QGridLayout>
#include <QHBoxLayout>
#include <QLabel>

#ifdef USE_EMBEDDED_EIGEN
	#include "EEigen.h"
#else
	#include <Eigen/Dense>	
#endif

#include "ImuData.h"

class EulerAngleWindow : public QWidget {
public:	
	EulerAngleWindow(QWidget* parent = 0);
	
	void updateData(ImuData imuData);
	
	QLabel *xLabel;
	QLabel *yLabel;
	QLabel *zLabel;
	
	Eigen::Vector3f eulerAngle;
};

#endif
	
	
	
	