#ifndef FIELD_MAP_CONTAINER
#define FIELD_MAP_CONTAINER

#include <QtGui>
#include <QGLWidget>
#include <QComboBox>
#include <QHBoxLayout>
#include <QVBoxLayout>

#include "FieldMapDisplay.h"
#include "FieldModuleIndicator.h"

class FieldMapContainer : public QWidget {
Q_OBJECT

public:
	FieldMapContainer(QWidget* parent = 0);
	void updateFieldMap(float magField[ABSMAXPITCH][ABSMAXROLL][ABSMAXYAW][3],
	float hardIronOffset[3], float softIronMatrix[3][3],
	float fieldStrength, float currentField[3]);
	void updateCurrentField(float fieldRadius, float currentField[3]);

	FieldMapDisplay* fmd;
	FieldModuleIndicator* fmi;
	QCheckBox* originalFieldCheck;
	QCheckBox* correctedFieldCheck;
	QCheckBox* ellipsoidCheck;
	
	QLabel* fieldRadiusLabel;
	QLabel* fieldOffsetLabel[3];
	QLabel* fieldDistortionLabel[3];
		
public slots:
	void updateGraphs(int v);
};

#endif