/***********************************************************************
** Copyright (C) 2011 LP-Research
** All rights reserved.
** Contact: LP-Research (klaus@lp-research.com)
**
** This file is part of the Open Motion Analysis Toolkit (OpenMAT).
**
** Redistribution and use in source and binary forms, with 
** or without modification, are permitted provided that the 
** following conditions are met:
**
** Redistributions of source code must retain the above copyright 
** notice, this list of conditions and the following disclaimer.
** Redistributions in binary form must reproduce the above copyright 
** notice, this list of conditions and the following disclaimer in 
** the documentation and/or other materials provided with the 
** distribution.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
** FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
** HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
***********************************************************************/

#include "MainWindow.h"

QGroupBox *MainWindow::doLpms(void)
{
	/* connectButton = new QPushButton("Connect");

	QPushButton *connectLpmsUButton = new QPushButton("Add / remove devices");
	QPushButton *connectWB4Button = new QPushButton("Connect to WB-4");
	QPushButton *connectLpmsCButton = new QPushButton("Connect to LPMS-C");
	QPushButton *disconnectButton = new QPushButton("Disconnect");	
	QPushButton *fakeModeButton = new QPushButton("Create test instance"); */
		
 	lpmsTree = new QTreeWidget();
 	lpmsTree->setColumnCount(1);
	lpmsTree->setHeaderLabel(QString("Connected devices"));
	currentLpms = 0;
	lpmsTree->selectionModel()->setCurrentIndex(QModelIndex(),QItemSelectionModel::Clear);
    lpmsTree->setVerticalScrollMode(QTreeView::ScrollPerPixel);
	
	/* calibrateMagButton = new QPushButton("Calibrate MAG");		
	startButton = new QPushButton("Start measurement");
	QPushButton *stopButton = new QPushButton("STOP measurement");
	QPushButton *calibrateButton = new QPushButton("GYRO calibration");
	QPushButton *iapButton = new QPushButton("Upload IAP");	
	QPushButton *firmwareButton = new QPushButton("Upload FIRMWARE");
	recordDataButton = new QPushButton("Record data");	
	QPushButton *saveCalibrationButton = new QPushButton("Save calibration data");
	QPushButton *resetOrientationButton = new QPushButton("Reset orientation ALL");
	QPushButton *resetOrientationSelectedButton = new QPushButton("Reset orientation");
	startServerButton = new QPushButton("Connect to data server");
	graphWindowButton = new QPushButton("Raw sensor data");
	graphWindow2Button = new QPushButton("Orientation data");	
	graphWindow3Button = new QPushButton("Pressure / Temp. data");
	threeDWindowButton = new QPushButton("3D visualization");
	fieldMapWindowButton = new QPushButton("Magnetic field map");
	QPushButton *exitButton = new QPushButton("Exit program");	*/	
	
	QSplitter *s0 = new QSplitter(Qt::Vertical);	
	
	QVBoxLayout *vl = new QVBoxLayout();
	
	s0->addWidget(deviceTree);
	s0->addWidget(lpmsTree);
	
	s0->setStretchFactor(0, 1);
	s0->setStretchFactor(1, 3);
	
	vl->addWidget(s0);
	
	/* QHBoxLayout* h0 = new QHBoxLayout();
	vl->addWidget(new QLabel("<u>Connection control</u>"));
	h0->addWidget(connectButton);
	h0->addWidget(disconnectButton);	
	h0->addWidget(connectLpmsUButton);	
	vl->addLayout(h0);
	
	QHBoxLayout* h1 = new QHBoxLayout();
	vl->addWidget(new QLabel("<u>Data acquisiton control</u>"));	
	h1->addWidget(startButton);	
	h1->addWidget(recordDataButton);	
	vl->addLayout(h1);
	
	vl->addWidget(new QLabel("<u>View control</u>"));		
	vl->addWidget(graphWindowButton);	
	vl->addWidget(graphWindow2Button);
	vl->addWidget(threeDWindowButton);	
	vl->addWidget(fieldMapWindowButton); */
		
	QGroupBox *gb = new QGroupBox("Sensor Control");
	gb->setLayout(vl);
		
	/* connect(calibrateMagButton, SIGNAL(clicked()), this, SLOT(calibrateMag()));	
	connect(startButton, SIGNAL(clicked()), this, SLOT(startMeasurement()));	
	connect(stopButton, SIGNAL(clicked()), this, SLOT(stopMeasurement()));	
	connect(calibrateButton, SIGNAL(clicked()), this, SLOT(recalibrate()));
	connect(recordDataButton, SIGNAL(clicked()), this, SLOT(recordData()));	
	connect(saveCalibrationButton, SIGNAL(clicked()), this, SLOT(saveCalibration()));		
	connect(lpmsTree, SIGNAL(currentItemChanged(QTreeWidgetItem *, QTreeWidgetItem *)), this, SLOT(updateCurrentLpms(QTreeWidgetItem *, QTreeWidgetItem *)));
	connect(resetOrientationButton, SIGNAL(clicked()), this, SLOT(zeroAngle()));
	connect(resetOrientationSelectedButton, SIGNAL(clicked()), this, SLOT(zeroAngleSelected()));
	connect(startServerButton, SIGNAL(clicked()), this, SLOT(startServer()));	
	connect(connectButton, SIGNAL(clicked()), this, SLOT(openSensor()));	
	connect(disconnectButton, SIGNAL(clicked()), this, SLOT(closeSensor()));	
	connect(graphWindowButton, SIGNAL(clicked()), this, SLOT(selectGraphWindow()));
	connect(graphWindow2Button, SIGNAL(clicked()), this, SLOT(selectGraph2Window()));
	connect(graphWindow3Button, SIGNAL(clicked()), this, SLOT(selectGraph3Window()));
	connect(threeDWindowButton, SIGNAL(clicked()), this, SLOT(selectThreeDWindow()));
	connect(fieldMapWindowButton, SIGNAL(clicked()), this, SLOT(selectFieldMapWindow()));
	connect(exitButton, SIGNAL(clicked()), this, SLOT(close()));
	connect(connectLpmsUButton, SIGNAL(clicked()), this, SLOT(addRemoveDevices()));		
	connect(firmwareButton, SIGNAL(clicked()), this, SLOT(uploadFirmware()));		
	connect(iapButton, SIGNAL(clicked()), this, SLOT(uploadIap()));	
	
	graphWindowButton->setStyleSheet("QPushButton { color: green; }");
	threeDWindowButton->setStyleSheet("QPushButton { color: black; }"); */
	
	return gb;
}

void MainWindow::closeEvent(QCloseEvent *event)
{
	if (exitWindow() == true) {
		event->accept();
	} else {
		event->ignore();
	}
}

QGroupBox* MainWindow::doStatus(void)
{
	QGridLayout *statusLayout = new QGridLayout();
	
	int i = 0;
	statusLayout->addWidget(new QLabel("<u>Measurement information</u>"), i, 0);
	++i;

	/* statusLayout->addWidget(new QLabel("Active LPMS Id"), i, 0);
	activeLpmsLabel = new QLabel("0");
	statusLayout->addWidget(activeLpmsLabel, i, 1);
	++i; */
		
	statusLayout->addWidget(new QLabel("Host update rate (ms)"), i, 0);
	imuFpsLabel = new QLabel("0");
	statusLayout->addWidget(imuFpsLabel, i, 1);
	++i;
	
	/* statusLayout->addWidget(new QLabel("LPMS Frame No."), i, 0);
	frameCountLabel = new QLabel("0");
	statusLayout->addWidget(frameCountLabel, i, 1);	
	++i; */
	
	statusLayout->addWidget(new QLabel("<u>Orientation</u>"), i, 0);	
	++i;	
	
	statusLayout->addWidget(new QLabel("Euler angle roll (deg)"), i, 0);
	xAngleLabel = new QLabel("0.0");
	statusLayout->addWidget(xAngleLabel, i, 1);	
	++i;
	
	statusLayout->addWidget(new QLabel("Euler angle pitch (deg)"), i, 0);
	yAngleLabel = new QLabel("0.0");
	statusLayout->addWidget(yAngleLabel, i, 1);	
	++i;
	
	statusLayout->addWidget(new QLabel("Euler angle yaw (deg)"), i, 0);
	zAngleLabel = new QLabel("0.0");
	statusLayout->addWidget(zAngleLabel, i, 1);		
	++i;
	
	statusLayout->addWidget(new QLabel("<u>Accelerometer</u>"), i, 0);	
	++i;

	statusLayout->addWidget(new QLabel("Acceleration X (g)"), i, 0);
	xAccLabel = new QLabel("0.0");
	statusLayout->addWidget(xAccLabel, i, 1);	
	++i;
			
	statusLayout->addWidget(new QLabel("Acceleration Y (g)"), i, 0);
	yAccLabel = new QLabel("0.0");
	statusLayout->addWidget(yAccLabel, i, 1);	
	++i;
	
	statusLayout->addWidget(new QLabel("Acceleration Z (g)"), i, 0);
	zAccLabel = new QLabel("0.0");
	statusLayout->addWidget(zAccLabel, i, 1);	
	++i;

	statusLayout->addWidget(new QLabel("<u>Gyroscope</u>"), i, 0);	
	++i;

	statusLayout->addWidget(new QLabel("Gyroscope X (deg/s)"), i, 0);
	xGyroLabel = new QLabel("0.0");
	statusLayout->addWidget(xGyroLabel, i, 1);	
	++i;
			
	statusLayout->addWidget(new QLabel("Gyroscope Y (deg/s)"), i, 0);
	yGyroLabel = new QLabel("0.0");
	statusLayout->addWidget(yGyroLabel, i, 1);	
	++i;
	
	statusLayout->addWidget(new QLabel("Gyroscope Z (deg/s)"), i, 0);
	zGyroLabel = new QLabel("0.0");
	statusLayout->addWidget(zGyroLabel, i, 1);
	++i;
	
	statusLayout->addWidget(new QLabel("<u>Magnetometer</u>"), i, 0);		
	++i;

	statusLayout->addWidget(new QLabel("Magnetometer X (uT)"), i, 0);
	xMagLabel = new QLabel("0.0");
	statusLayout->addWidget(xMagLabel, i, 1);	
	++i;
			
	statusLayout->addWidget(new QLabel("Magnetometer Y (uT)"), i, 0);
	yMagLabel = new QLabel("0.0");
	statusLayout->addWidget(yMagLabel, i, 1);	
	++i;
	
	statusLayout->addWidget(new QLabel("Magnetometer Z (uT)"), i, 0);
	zMagLabel = new QLabel("0.0");
	statusLayout->addWidget(zMagLabel, i, 1);	
	++i;
	
	/* statusLayout->addWidget(new QLabel("Magnetometer range"), i, 0);
	magRangeLabel = new QLabel("<font color='green'>OK</font>");
	statusLayout->addWidget(magRangeLabel, i, 1);	
	++i; */	

	statusLayout->addWidget(new QLabel("<u>Quaternion</u>"), i, 0);		
	++i;

	statusLayout->addWidget(new QLabel("Quaternion X (rel.u)"), i, 0);
	xQuatLabel = new QLabel("0.0");
	statusLayout->addWidget(xQuatLabel, i, 1);	
	++i;
			
	statusLayout->addWidget(new QLabel("Quaternion Y (rel.u)"), i, 0);
	yQuatLabel = new QLabel("0.0");
	statusLayout->addWidget(yQuatLabel, i, 1);	
	++i;
	
	statusLayout->addWidget(new QLabel("Quaternion Z (rel.u)"), i, 0);
	zQuatLabel = new QLabel("0.0");
	statusLayout->addWidget(zQuatLabel, i, 1);
	++i;
	
	statusLayout->addWidget(new QLabel("Quaternion W (rel.u)"), i, 0);
	wQuatLabel = new QLabel("0.0");
	statusLayout->addWidget(wQuatLabel, i, 1);			
	++i;
	
	statusLayout->addWidget(new QLabel("<u>Linear acceleration</u>"), i, 0);		
	++i;

	statusLayout->addWidget(new QLabel("Lin. acceleration X (g)"), i, 0);
	xLinAccLabel = new QLabel("0.0");
	statusLayout->addWidget(xLinAccLabel, i, 1);	
	++i;
			
	statusLayout->addWidget(new QLabel("Lin. acceleration Y (g)"), i, 0);
	yLinAccLabel = new QLabel("0.0");
	statusLayout->addWidget(yLinAccLabel, i, 1);	
	++i;
	
	statusLayout->addWidget(new QLabel("Lin. acceleration Z (g)"), i, 0);
	zLinAccLabel = new QLabel("0.0");
	statusLayout->addWidget(zLinAccLabel, i, 1);
	++i;

#ifdef SHOW_PRESSURE
	statusLayout->addWidget(new QLabel("<u>Altitude</u>"), i, 0);		
	++i;

	statusLayout->addWidget(new QLabel("Altitude (m)"), i, 0);
	pressureLabel = new QLabel("0.0");
	statusLayout->addWidget(pressureLabel, i, 1);			
	++i;
#endif

	statusLayout->setColumnMinimumWidth(1, 80);

	QGroupBox *statusGroupBox = new QGroupBox("Status");
	statusGroupBox->setLayout(statusLayout);
	
	return statusGroupBox;
}

QGroupBox *MainWindow::doGraph(void)
{
	QVBoxLayout* graphLayout = new QVBoxLayout();
	graphWindow = new GraphWindow();
	threeDWindow = new ThreeDWindow();
	fieldMapWindow = new FieldMapContainer();
	// sanAngeles = new SanAngelesWindow();
	
	/* eulerAngleWindow = new EulerAngleWindow();
	graphLayout->addWidget(eulerAngleWindow); */
	
	graphLayout->addWidget(graphWindow);
	graphLayout->addWidget(threeDWindow);
	graphLayout->addWidget(fieldMapWindow);
	// graphLayout->addWidget(sanAngeles);
	
	/* graphLayout->setStretch(0, 0);
	graphLayout->setStretch(1, 100);
	graphLayout->setStretch(2, 100); */
	
	threeDWindow->hide();
	fieldMapWindow->hide();
	// graphWindow->hide();
	
	QGroupBox *graphGroupBox = new QGroupBox("Data");
	graphGroupBox->setLayout(graphLayout);	
	
	// deviceTree->startDiscoverDevices();
	
	return graphGroupBox;
}

QGroupBox *MainWindow::doConsole(void)
{
	QVBoxLayout *vb = new QVBoxLayout();
	vb->addWidget(consoleWindow);
	
	QGroupBox *consoleGroupBox = new QGroupBox("Status log");
	consoleGroupBox->setLayout(vb);
	
	return consoleGroupBox;
}

void MainWindow::doMenus(void)
{
	QToolBar *tb = addToolBar("Toolbar");
	QMenu* connectMenu = menuBar()->addMenu("&Connect");
	
	QAction* connectAction = new QAction(QIcon("./icons/bolt_32x32.png"), "&Connect", this);
	QAction* disconnectAction = new QAction(QIcon("./icons/x_28x28.png"), "&Disconnect", this);	
	QAction* addRemoveAction = new QAction(QIcon("./icons/plus_32x32.png"), "&Add / remove sensor", this);	
	QAction* exitAction = new QAction("E&xit program", this);		

	connectMenu->addAction(connectAction);
	connectMenu->addAction(disconnectAction);
	connectMenu->addAction(addRemoveAction);
	connectMenu->addSeparator();	
	connectMenu->addAction(exitAction);	

	tb->addAction(connectAction);
	tb->addAction(disconnectAction);
	tb->addAction(addRemoveAction);
	
	QMenu* measurementMenu = menuBar()->addMenu("&Measurement");
	startAction = new QAction(QIcon("./icons/play_24x32.png"), "&Start measurement", this);
	QAction* stopAction = new QAction("Stop measurement", this);
	saveAction = new QAction(QIcon("./icons/cd_32x32.png"), "&Record data", this);	
	
	measurementMenu->addAction(startAction);
	measurementMenu->addAction(saveAction);

	tb->addSeparator();
	tb->addAction(startAction);
	tb->addAction(saveAction);

	QMenu* calibrationMenu = menuBar()->addMenu("&Calibration");
	QAction* resetOrientationAction = new QAction("Reset &orientation", this);	
	QAction* gyroAction = new QAction("Calibrate &gyroscope", this);
	QAction* startMagAction = new QAction("Calibrate &magnetometer", this);
	QAction* stopMagAction = new QAction("Stop magnetometer calibration", this);	
	QAction* resetRefAction = new QAction("Reset &references", this);
	QAction* saveCalAction = new QAction("Save &parameters to sensor", this);
	QAction* resetToFactoryAction = new QAction("Reset to factory settings", this);		
	QAction* loadFromFileAction = new QAction("Save parameters to file", this);		
	QAction* saveToFileAction = new QAction("Load parameters from file", this);		
	
	calibrationMenu->addAction(resetOrientationAction);
	calibrationMenu->addAction(resetRefAction);	
	calibrationMenu->addSeparator();
	calibrationMenu->addAction(gyroAction);
	calibrationMenu->addAction(startMagAction);
	calibrationMenu->addSeparator();
	calibrationMenu->addAction(saveCalAction);
	calibrationMenu->addAction(loadFromFileAction);
	calibrationMenu->addAction(saveToFileAction);	
	calibrationMenu->addSeparator();
	calibrationMenu->addAction(resetToFactoryAction);
	
	QMenu* openMatMenu = menuBar()->addMenu("&OpenMAT");
	QAction* versionAction = new QAction("Version info", this);
	QAction* openmatAction = new QAction("Connect to &OpenMAT server", this);	
	openMatMenu->addAction(openmatAction);
	openMatMenu->addSeparator();
	openMatMenu->addAction(versionAction);
	
	QMenu* viewMenu = menuBar()->addMenu("&View");
	QAction* graphAction = new QAction(QIcon("./icons/rss_alt_32x32.png"), "Graph &window", this);
	QAction* orientationGraphAction = new QAction(QIcon("./icons/target_32x32.png"), "Orien&tation window", this);
	QAction* threedAction = new QAction(QIcon("./icons/share_32x32.png"), "3D &visualization", this);
	QAction* fieldMapAction = new QAction(QIcon("./icons/sun_fill_32x32.png"), "Magnetic field map", this);

	viewMenu->addAction(graphAction);
	viewMenu->addAction(orientationGraphAction);
	viewMenu->addAction(threedAction);
	viewMenu->addAction(fieldMapAction);
	
	tb->addSeparator();
	tb->addAction(graphAction);
	tb->addAction(orientationGraphAction);
	tb->addAction(threedAction);
	tb->addAction(fieldMapAction); 

	QMenu* expertMenu = menuBar()->addMenu("&Expert");
	QAction* firmwareAction = new QAction("Upload firmware", this);
	QAction* iapAction = new QAction("Upload IAP", this);
	selfTestAction = new QAction("Start self test", this);
	QAction* latencyAction = new QAction("Measure latency", this);
	QAction* getFieldMapAction = new QAction("Get field map", this);
	QAction* mACalculateAction = new QAction("Calibrate misalignment", this);

	expertMenu->addAction(firmwareAction);
	expertMenu->addAction(iapAction);	
	expertMenu->addSeparator();
	expertMenu->addAction(selfTestAction);
	expertMenu->addSeparator();
	expertMenu->addAction(mACalculateAction);
	
	connect(startMagAction, SIGNAL(triggered()), this, SLOT(calibrateMag()));	
	connect(startAction, SIGNAL(triggered()), this, SLOT(startMeasurement()));		
	connect(gyroAction, SIGNAL(triggered()), this, SLOT(recalibrate()));
	connect(saveAction, SIGNAL(triggered()), this, SLOT(recordData()));	
	connect(saveCalAction, SIGNAL(triggered()), this, SLOT(saveCalibration()));		
	connect(resetRefAction, SIGNAL(triggered()), this, SLOT(zeroAngle()));
	connect(resetOrientationAction, SIGNAL(triggered()), this, SLOT(zeroAngleSelected()));
	connect(openmatAction, SIGNAL(triggered()), this, SLOT(startServer()));	
	connect(connectAction, SIGNAL(triggered()), this, SLOT(openSensor()));	
	connect(disconnectAction, SIGNAL(triggered()), this, SLOT(closeSensor()));
	connect(graphAction, SIGNAL(triggered()), this, SLOT(selectGraphWindow()));
	connect(orientationGraphAction, SIGNAL(triggered()), this, SLOT(selectGraph2Window()));	
	connect(threedAction, SIGNAL(triggered()), this, SLOT(selectThreeDWindow()));
	connect(exitAction, SIGNAL(triggered()), this, SLOT(close()));
	connect(firmwareAction, SIGNAL(triggered()), this, SLOT(uploadFirmware()));		
	connect(iapAction, SIGNAL(triggered()), this, SLOT(uploadIap()));
	connect(selfTestAction, SIGNAL(triggered()), this, SLOT(toggleSelfTest()));
	connect(latencyAction, SIGNAL(triggered()), this, SLOT(measureLatency()));
	connect(getFieldMapAction, SIGNAL(triggered()), this, SLOT(getFieldMap()));
	connect(versionAction, SIGNAL(triggered()), this, SLOT(getVersionInfo()));
	connect(fieldMapAction, SIGNAL(triggered()), this, SLOT(selectFieldMapWindow()));
	connect(resetToFactoryAction, SIGNAL(triggered()), this, SLOT(resetToFactory()));
	connect(mACalculateAction, SIGNAL(triggered()), this, SLOT(misalignmentCal()));
	connect(loadFromFileAction, SIGNAL(triggered()), this, SLOT(loadCalibrationData()));
	connect(saveToFileAction, SIGNAL(triggered()), this, SLOT(saveCalibrationData()));
	connect(addRemoveAction, SIGNAL(triggered()), this, SLOT(addRemoveDevices()));
}

#include "RescanDialog.h"

MainWindow::MainWindow(QWidget *parent)
{	
	std::cout << "[OpenMAT LPMS Control] Initializing program" << std::endl;
	
	doMenus();
	
	sd = new SaveDataThread();	
	sm = LpmsSensorManagerFactory();
	
#ifdef USE_ZEROC_ICE
	isp = new IceStormPublisher();
#endif
	
	deviceTree = new DiscoveryTree(sm, "Preferred devices", this);
	deviceTree->readFromFile(PREFERRED_DEVICES_FILE);

	QSplitter *s0 = new QSplitter();
	s0->addWidget(doLpms());

	s0->addWidget(doGraph());
	s0->addWidget(doStatus());
	
	s0->setStretchFactor(0, 6);
	s0->setStretchFactor(1, 10);
	s0->setStretchFactor(2, 5);
		
	QHBoxLayout *h0 = new QHBoxLayout();
	h0->addWidget(s0);
	
	QWidget* cw = new QWidget();
	cw->setLayout(h0);
	setCentralWidget(cw);
		
	this->setMinimumSize(1024, 768);
	showMaximized();
	
	setWindowTitle("OpenMAT LPMS Control");
	
	isRunning = false;
	isConnecting = false;
	calibratingMag	= false;
	
	startServer();
	
	QTimer* timer = new QTimer(this);
	connect(timer, SIGNAL(timeout()), this, SLOT(timerUpdate()));
    timer->start(40);
	
	textUpdateCounter = 0;
	maIsCalibrating = false;

	/* QTimer* discoveryTimer = new QTimer(this);
	connect(discoveryTimer, SIGNAL(timeout()), this, SLOT(discoveryTimerUpdate()));
	discoveryTimer->start(1000); */
}	

void MainWindow::discoveryTimerUpdate(void)
{
	// deviceTree->updateDevices();
}

void MainWindow::calibrateMag(void)
{
	if (currentLpms == 0 || isConnecting == true) return;
	
	if (isRunning == false) startMeasurement();
	
	currentLpms->getSensor()->startCalibrateMag();
	
	startWaitBar(40);
}

void MainWindow::startServer(void)
{
#ifdef USE_ZEROC_ICE
	if (isp->checkConnected() == true) {
		isp->disconnect();
	} else {
		isp->connect();
		if (isp->checkConnected() == true) {
		} else {
		}
	}
#endif
}	

void MainWindow::updateCurrentLpms(QTreeWidgetItem *current, QTreeWidgetItem *previous)
{
	bool f;
	int i;
	int fi;
	
	std::list<SensorGuiContainer *>::iterator it;
	std::list<SensorGuiContainer *>::iterator fit;	
	
	f = false;
	i = 0;
	fi = 0;
		
	QTreeWidgetItem *temp;	
		
	if (lpmsTree->indexOfTopLevelItem(lpmsTree->currentItem()) == -1) {
		return;
	}
		
	temp = lpmsTree->currentItem();
		
	for (it = lpmsList.begin(); it != lpmsList.end(); ++it) {
		(*it)->updateData();
		if (lpmsTree->indexOfTopLevelItem(lpmsTree->currentItem()) == lpmsTree->indexOfTopLevelItem((*it)->treeItem)) {
			f = true;
			fit = it;
			fi = i;
		}		
		
		++i;
	}	
	
	if (f == true) {		
		currentLpms = *fit;
				
		currentLpms->openMatId = (*fit)->getSensor()->getOpenMatId();		
		graphWindow->setActiveLpms((*fit)->getSensor()->getOpenMatId());
		threeDWindow->setActiveLpms((*fit)->getSensor()->getOpenMatId());
		
		// activeLpmsLabel->setText(QString("%1").arg((*fit)->getSensor()->getOpenMatId()));
	} else {
		if (lpmsTree->topLevelItemCount() > 0) {	
			currentLpms = lpmsList.front();
		} else {
			currentLpms = 0;
			
			startButton->setStyleSheet("QPushButton { color: black; }");	
			startButton->setText("Start measurement");	

			isRunning = false;
		}
	}

	graphWindow->clearGraphs();
}

void MainWindow::timerUpdate(void)
{
	list<SensorGuiContainer *>::iterator it;	
	float fieldMap[ABSMAXPITCH][ABSMAXROLL][ABSMAXYAW][3];
	float hardIronOffset[3];
	float softIronMatrix[3][3];
	float fieldRadius;

	for (it = lpmsList.begin(); it != lpmsList.end(); ++it) {
		(*it)->updateData();
		
		if ((*it)->getSensor()->getSensorStatus() == SENSOR_CONNECTION_CONNECTED && 
			(*it)->getSensor()->getSensorStatus() == SENSOR_STATUS_RUNNING) {
			ImuData imuData = (*it)->getSensor()->getCurrentData();
#ifdef USE_ZEROC_ICE
			isp->updateImuData(imuData);
#endif
			
			if ((*it) == currentLpms) {
			
				if (textUpdateCounter > 0) {
					xAccLabel->setText(QString("%1").arg(imuData.a[0], -8, 'f', 2));
					yAccLabel->setText(QString("%1").arg(imuData.a[1], -8, 'f', 2));
					zAccLabel->setText(QString("%1").arg(imuData.a[2], -8, 'f', 2));
					xGyroLabel->setText(QString("%1").arg(imuData.g[0], -8, 'f', 2));
					yGyroLabel->setText(QString("%1").arg(imuData.g[1], -8, 'f', 2));
					zGyroLabel->setText(QString("%1").arg(imuData.g[2], -8, 'f', 2));	
					xMagLabel->setText(QString("%1").arg(imuData.b[0], -8, 'f', 2));
					yMagLabel->setText(QString("%1").arg(imuData.b[1], -8, 'f', 2));
					zMagLabel->setText(QString("%1").arg(imuData.b[2], -8, 'f', 2));
					
					wQuatLabel->setText(QString("%1").arg(imuData.q[0], -8, 'f', 2));
					xQuatLabel->setText(QString("%1").arg(imuData.q[1], -8, 'f', 2));
					yQuatLabel->setText(QString("%1").arg(imuData.q[2], -8, 'f', 2));
					zQuatLabel->setText(QString("%1").arg(imuData.q[3], -8, 'f', 2));
					
					xAngleLabel->setText(QString("%1").arg(imuData.r[0], -8, 'f', 2));
					yAngleLabel->setText(QString("%1").arg(imuData.r[1], -8, 'f', 2));
					zAngleLabel->setText(QString("%1").arg(imuData.r[2], -8, 'f', 2));
					
					xLinAccLabel->setText(QString("%1").arg(imuData.linAcc[0], -8, 'f', 2));
					yLinAccLabel->setText(QString("%1").arg(imuData.linAcc[1], -8, 'f', 2));
					zLinAccLabel->setText(QString("%1").arg(imuData.linAcc[2], -8, 'f', 2));
					
#ifdef SHOW_PRESSURE
					pressureLabel->setText(QString("%1").arg(imuData.p, -8, 'f', 2));
#endif
					
					// frameCountLabel->setText(QString("%1").arg(imuData.frameCount));
					imuFpsLabel->setText(QString("%1").arg((*it)->getSensor()->getFps()));	
					
					/* if ((*it)->getSensor()->getMagOutofrange() == true) {
						magRangeLabel->setText("<font color='red'>OUT</font>");				
					} else {
						magRangeLabel->setText("<font color='green'>OK</font>");			
					} */
					
					textUpdateCounter = 0;
				} else {
					textUpdateCounter++;
				}
				
				graphWindow->plotDataSet(imuData);
				// eulerAngleWindow->updateData(imuData);
				threeDWindow->updateQuaternion(imuData);
				// sanAngeles->updateQuaternion(imuData);

				if ((*it)->getSensor()->hasNewFieldMap() == true) {
					(*it)->getSensor()->getFieldMap(fieldMap);
					(*it)->getSensor()->getHardIronOffset(hardIronOffset);
					(*it)->getSensor()->getSoftIronMatrix(softIronMatrix, &fieldRadius);
					fieldMapWindow->updateFieldMap(fieldMap, hardIronOffset, softIronMatrix, fieldRadius,
					imuData.b);
				}
							
				(*it)->getSensor()->getSoftIronMatrix(softIronMatrix, &fieldRadius);
				fieldMapWindow->updateCurrentField((*it)->getSensor()->getFieldNoise(), imuData.b);
			}
		}
	}
}

void MainWindow::openSensor(void)
{
	int mode;
	bool f;

	if (isConnecting == true) return;
	
	QTreeWidgetItemIterator tii(deviceTree);

	if (*tii == 0) return;	
	
	mode = deviceTree->getCurrentDeviceType();
	
	isConnecting = true;	
	string deviceAddress;
	
	switch (mode) {
		case DEVICE_LPMS_B:
			deviceAddress = deviceTree->getCurrentDeviceId();
			break;

		case DEVICE_LPMS_U:	
			deviceAddress = deviceTree->getCurrentDeviceId();
			break;
			
		case DEVICE_LPMS_C:	
			deviceAddress = deviceTree->getCurrentDeviceId();
			break;
	}

	f = false;
	std::list<SensorGuiContainer *>::iterator it;		
	for (it = lpmsList.begin(); it != lpmsList.end(); ++it) {
		if ((*it)->getSensor()->getDeviceId() == deviceAddress) {
			f = true;
		}
	}
	
	if (f == true) {
		std::cout << "[LpmsControl] Device " << deviceAddress.c_str() << " is already connected" << std::endl;
		isConnecting = false;
		return;
	} 
	
	stopMeasurement();
	graphWindow->clearGraphs();	
	
	LpmsSensorI *lpmsDevice = sm->addSensor(mode, deviceAddress);
	currentLpms = new SensorGuiContainer(lpmsDevice, lpmsTree);

#ifdef USE_ZEROC_ICE
	isp->addSensor(lpmsDevice);
#endif	
	
	sd->addSensor(lpmsDevice);
	currentLpms->updateData();

	lpmsList.push_back(currentLpms);

	lpmsTree->insertTopLevelItem(0, currentLpms->treeItem);	
	lpmsTree->setCurrentItem(currentLpms->treeItem);
	
	currentLpms->treeItem->setExpanded(true);	
	
	isConnecting = false;	
	startMeasurement();
}

void MainWindow::closeSensor(void)
{
	if (currentLpms == 0 || isConnecting == true) return;
	
	stopMeasurement();
	
	if (currentLpms) {
		SensorGuiContainer *temp = currentLpms;	

#ifdef USE_ZEROC_ICE
		isp->removeSensor(temp->getSensor());
#endif

		sd->removeSensor(temp->getSensor());
		sm->removeSensor(temp->getSensor());
		lpmsList.remove(temp);
		delete temp->treeItem;
		currentLpms = 0;
		delete temp;
		updateCurrentLpms();			
	}
}

void MainWindow::toggleSelfTest(void)
{
	int i;

	if (currentLpms == 0 || isConnecting == true) return;
	
	currentLpms->getSensor()->getConfigurationPrm(PRM_SELF_TEST, &i);		

	if (i == SELECT_SELF_TEST_OFF) {
		selfTestAction->setText("Start self test");
		currentLpms->getSensor()->setConfigurationPrm(PRM_SELF_TEST, SELECT_SELF_TEST_ON);
	} else {
		selfTestAction->setText("Stop self test");
		currentLpms->getSensor()->setConfigurationPrm(PRM_SELF_TEST, SELECT_SELF_TEST_OFF);		
	}
}

void MainWindow::startMeasurement(void)
{
	std::list<SensorGuiContainer *>::iterator it;

	if (isConnecting == true) return;
	
	if (isRunning == false && lpmsList.size() > 0) {
		for (it = lpmsList.begin(); it != lpmsList.end(); ++it) {	
			(*it)->getSensor()->run();
		}
		
		startAction->setText("Stop measurement");
		startAction->setIcon(QIcon("./icons/stop_32x32.png"));

		// startButton->setStyleSheet("QPushButton { color: green; }");	
		// startButton->setText("Stop measurement");	

		graphWindow->clearGraphs();
		
		isRunning = true;
	} else {
		for (it = lpmsList.begin(); it != lpmsList.end(); ++it) {	
			(*it)->getSensor()->pause();
		}

		startAction->setText("Start measurement");
		startAction->setIcon(QIcon("./icons/play_24x32.png"));

		// startButton->setStyleSheet("QPushButton { color: black; }");
		// startButton->setText("Start measurement");	

		isRunning = false;
	}	
}

void MainWindow::stopMeasurement(void)
{
	std::list<SensorGuiContainer *>::iterator it;

	for (it = lpmsList.begin(); it != lpmsList.end(); ++it) {	
		(*it)->getSensor()->pause();
	}

	startAction->setText("Start measurement");
	startAction->setIcon(QIcon("./icons/play_24x32.png"));

	// startButton->setStyleSheet("QPushButton { color: black; }");	
	// startButton->setText("Start measurement");	

	isRunning = false;
}

void MainWindow::zeroAngle(void)
{
	if (currentLpms == 0 || isConnecting == true) {
		return;
	}		
		
	currentLpms->getSensor()->startResetReference();
}

void MainWindow::zeroAngleSelected(void)
{
	QMessageBox msgBox;
	int ret;

	std::list<SensorGuiContainer *>::iterator it;

	if (currentLpms == 0 || isConnecting == true) {
		return;
	}	
	
	msgBox.setText("This command sets the current sensor orientation "
		"as zero-position. You can remove this offset again by re-"
		"setting the sensor references. Would like to proceed?");
	msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);

	msgBox.setDefaultButton(QMessageBox::No);
	ret = msgBox.exec();

	switch (ret) {
		case QMessageBox::Yes:
			break;
			
		case QMessageBox::No:
			return;
			break;
			
		default:
			break;
	}	
	
	for (it = lpmsList.begin(); it != lpmsList.end(); ++it) {	
		(*it)->getSensor()->resetOrientation();
	}	
}

void MainWindow::recalibrate(void)
{
	if (currentLpms == 0 || isConnecting == true) {
		return;
	}	
	
	if (isRunning == false) {
		startMeasurement();
	}	
	
	currentLpms->getSensor()->startCalibrateGyro();	
	
	startWaitBar(10);
}

void MainWindow::uploadFirmware(void)
{
	QMessageBox msgBox;
	int ret;

	if (currentLpms == 0 || isConnecting == true) {
		return;
	}

	msgBox.setText("By uploading an invalid firmware file, the sensor can become "
		"in-operable. Are you sure that you understand what you are doing and "
		"would like to proceed?");
	msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);

	msgBox.setDefaultButton(QMessageBox::No);
	ret = msgBox.exec();

	switch (ret) {
		case QMessageBox::Yes:
			break;
			
		case QMessageBox::No:
			return;
			break;
			
		default:
			break;
	}

	QString qfilename = QFileDialog::getOpenFileName(this, "Open firmware file", "./", "");
	string fn = qfilename.toStdString();
	
	if (!(fn == "")) {		
		currentLpms->getSensor()->uploadFirmware(fn);
	}
	
	uploadProgress = new QProgressDialog("Uploading data, please don't turn off your device...", "Cancel", 0, 200, this);
	uploadProgress->setWindowModality(Qt::WindowModal);
	uploadProgress->setMinimumWidth(400);
	uploadProgress->setAutoReset(false);
	uploadProgress->setCancelButton(0);
	uploadProgress->show();
	
	uploadTimer = new QTimer(this);
	connect(uploadTimer, SIGNAL(timeout()), this, SLOT(uploadTimerUpdate()));
    uploadTimer->start(500);	
}

void MainWindow::uploadTimerUpdate(void)
{	
	int p;

	if (currentLpms->getSensor()->getUploadProgress(&p) == true) {
		uploadProgress->setValue(p);
		uploadProgress->show();
	} else {
		QMessageBox msgBox;
	
	    delete uploadTimer;
		delete uploadProgress;
		
		msgBox.setText("Upload has been successfully finished.");
		msgBox.exec();
	}	
}

void MainWindow::uploadIap(void)
{
	QMessageBox msgBox;
	int ret;

	if (currentLpms == 0 || isConnecting == true) {
		return;
	}

	msgBox.setText("By uploading an invalid IAP file, the sensor can become "
		"in-operable. Are you sure that you understand what you are doing and "
		"would like to proceed?");
	msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);

	msgBox.setDefaultButton(QMessageBox::No);
	ret = msgBox.exec();

	switch (ret) {
		case QMessageBox::Yes:
			break;
			
		case QMessageBox::No:
			return;
			break;
			
		default:
			break;
	}

	QString qfilename = QFileDialog::getOpenFileName(this, "Open IAP file", "./", "");
	string fn = qfilename.toStdString();

	if (!(fn == "")) {	
		currentLpms->getSensor()->uploadIap(fn);
	}
	
	uploadProgress = new QProgressDialog("Uploading data, please don't turn off your device...", "Cancel", 0, 200, this);
	uploadProgress->setWindowModality(Qt::WindowModal);
	uploadProgress->setMinimumWidth(400);
	uploadProgress->setAutoReset(false);	
	uploadProgress->setCancelButton(0);
	uploadProgress->show();
	
	uploadTimer = new QTimer(this);
	connect(uploadTimer, SIGNAL(timeout()), this, SLOT(uploadTimerUpdate()));
    uploadTimer->start(500);	
}
	
void MainWindow::recordData(void)
{
	if (currentLpms == 0 || isConnecting == true) {
		return;
	}
		
	if (sd->isRecording() == false) {
		stopMeasurement();
		QString qfilename = QFileDialog::getSaveFileName(this, "Save sensor data", "./", "");
		string record_filename = qfilename.toStdString();
		
		if (!(record_filename == "")) {					
			if (sd->startSaveImuData(record_filename) == true) {

				saveAction->setText("Stop recording");
				saveAction->setIcon(QIcon("./icons/aperture_alt_32x32.png"));

				// recordDataButton->setStyleSheet("QPushButton { color: green; }");	
				// recordDataButton->setText("Stop recording");
			}
		}
		startMeasurement();	
	} else {
		sd->stopSaveImuData();

		saveAction->setText("Record data");
		saveAction->setIcon(QIcon("./icons/cd_32x32.png"));

		// recordDataButton->setStyleSheet("QPushButton { color: black; }");			
		// recordDataButton->setText("Record data");
	}	
}	

void MainWindow::selectGraphWindow(void)
{
	threeDWindow->hide();
	graphWindow->setMode(GRAPH_MODE_RAW);
	graphWindow->show();
	fieldMapWindow->hide();
	
	/* graphWindowButton->setStyleSheet("QPushButton { color: green; }");
	graphWindow2Button->setStyleSheet("QPushButton { color: black; }");
	graphWindow3Button->setStyleSheet("QPushButton { color: black; }");		
	threeDWindowButton->setStyleSheet("QPushButton { color: black; }");
	fieldMapWindowButton->setStyleSheet("QPushButton { color: black; }"); */
}

void MainWindow::selectGraph2Window(void)
{
	threeDWindow->hide();	
	graphWindow->setMode(GRAPH_MODE_ORIENTATION);
	graphWindow->show();
	fieldMapWindow->hide();
	
	/* graphWindowButton->setStyleSheet("QPushButton { color: black; }");
	graphWindow2Button->setStyleSheet("QPushButton { color: green; }");
	graphWindow3Button->setStyleSheet("QPushButton { color: black; }");	
	threeDWindowButton->setStyleSheet("QPushButton { color: black; }");
	fieldMapWindowButton->setStyleSheet("QPushButton { color: black; }"); */
}

void MainWindow::selectGraph3Window(void)
{
	threeDWindow->hide();	
	graphWindow->setMode(GRAPH_MODE_PRESSURE);
	graphWindow->show();
	fieldMapWindow->hide();	
	
	/* graphWindowButton->setStyleSheet("QPushButton { color: black; }");
	graphWindow2Button->setStyleSheet("QPushButton { color: black; }");	
	graphWindow3Button->setStyleSheet("QPushButton { color: green; }");	
	threeDWindowButton->setStyleSheet("QPushButton { color: black; }");
	fieldMapWindowButton->setStyleSheet("QPushButton { color: black; }"); */
}

void MainWindow::selectThreeDWindow(void)
{
	graphWindow->hide();
	threeDWindow->update();
	threeDWindow->show();
	fieldMapWindow->hide();
	
	/* graphWindowButton->setStyleSheet("QPushButton { color: black; }");
	graphWindow2Button->setStyleSheet("QPushButton { color: black; }");	
	graphWindow3Button->setStyleSheet("QPushButton { color: black; }");
	threeDWindowButton->setStyleSheet("QPushButton { color: green; }");	
	fieldMapWindowButton->setStyleSheet("QPushButton { color: black; }"); */
}

void MainWindow::selectFieldMapWindow(void)
{
	graphWindow->hide();
	threeDWindow->hide();
	fieldMapWindow->show();
	
	/* graphWindowButton->setStyleSheet("QPushButton { color: black; }");
	graphWindow2Button->setStyleSheet("QPushButton { color: black; }");	
	graphWindow3Button->setStyleSheet("QPushButton { color: black; }");
	threeDWindowButton->setStyleSheet("QPushButton { color: black; }");	
	fieldMapWindowButton->setStyleSheet("QPushButton { color: green; }"); */
}

bool MainWindow::exitWindow(void)
{
	QMessageBox msgBox;
	int ret;

	// if (isConnecting == true) return false;
	
	msgBox.setText("Do you really want to quit?");
	msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);
	msgBox.setDefaultButton(QMessageBox::No);
	ret = msgBox.exec();

	switch (ret) {
		case QMessageBox::Yes:
			closeSensor();
			return true;
			break;
			
		case QMessageBox::No:
			break;
			
		default:
			break;
	}
	
	return false;
}

MainWindow::~MainWindow()
{
}

void MainWindow::saveCalibration(void)
{
	if (currentLpms == 0 || isConnecting == true) return;
	
	currentLpms->getSensor()->saveCalibrationData();
}

void MainWindow::updateLpmsFps(int v, int lpmsId)
{
	if (lpmsId == currentLpms->getSensor()->getOpenMatId()) {
		imuFpsLabel->setText(QString("%1").arg(v));
	}
}

void MainWindow::measureLatency(void)
{
	if (currentLpms == 0 || isConnecting == true) return;
	
	currentLpms->getSensor()->measureAvgLatency();
}

void MainWindow::getFieldMap(void)
{
	if (currentLpms == 0 || isConnecting == true) return;

	currentLpms->getSensor()->acquireFieldMap();	
}

void MainWindow::getVersionInfo(void)
{
	QString openMATVersion("1.0.13");	
	QMessageBox::about(this, "OpenMAT - LpmsControl", QString("OpenMAT - LpmsControl ") + openMATVersion + QString("\n(c) LP-Research\nhttp://www.lp-research.com\n\nThis software is licensed under the Simplified BSD License (http://opensource.org/licenses/bsd-license.php).\n\nCREDITS:\nQWT: Uwe Rathmann, Josef Wilgen (http://qwt.sourceforge.net/)\nQT: QT-Project (http://qt-project.org/)\nApplication icon: Fast Icon (http://www.fasticon.com)\nPugiXML: Arseny Kapoulkine (http://pugixml.org/)\nBoost: Boost.org (http://www.boost.org/)\nToolbar icons: P.J. Onori (http://somerandomdude.com/work/iconic/)"));
}

void MainWindow::resetToFactory(void)
{
	if (currentLpms == 0 || isConnecting == true) return;

	currentLpms->getSensor()->resetToFactorySettings();
}

QWizardPage *MainWindow::maOrientationPage(char* ts, char* es)
{
	QWizardPage *page = new QWizardPage;
	
	page->setTitle((std::string("Calibrating to orientation: ") + std::string(ts)).c_str());

	QLabel *label = new QLabel((std::string("Please put the selected LPMS on a horizontal surface, with the ") + std::string(es) + std::string("After aligning the sensor in this orientation press the next button. Please do not move the sensor for around 3s.")).c_str());
	label->setWordWrap(true);

	QVBoxLayout *layout = new QVBoxLayout;
	layout->addWidget(label);
	page->setLayout(layout);

	return page;
}

QWizardPage *MainWindow::maFinishedPage(void)
{
	QWizardPage *page = new QWizardPage;
	
	page->setTitle("Calibration finished");

	QLabel *label = new QLabel("Misalignment calibration has been finished successfully.");
	label->setWordWrap(true);

	QVBoxLayout *layout = new QVBoxLayout;
	layout->addWidget(label);
	page->setLayout(layout);

	return page;
}

void MainWindow::misalignmentCal(void)
{
	QMessageBox msgBox;
	int ret;

	if (currentLpms == 0 || isConnecting == true) return;

	msgBox.setText("Changing the misalignment matrix can significantly "
		"affect the performance of your sensor. Before setting a new "
		"misalignment matrix, please make sure that you know what you "
		"are doing. Anyway, parameters will not be saved to the internal "
		"flash memory of the sensor until you choose to save calibration "
		"parameters.");
	msgBox.setStandardButtons(QMessageBox::Yes | QMessageBox::No);

	msgBox.setDefaultButton(QMessageBox::No);
	ret = msgBox.exec();

	switch (ret) {
		case QMessageBox::Yes:
			break;
			
		case QMessageBox::No:
			return;
			break;
			
		default:
			break;
	}
	
	maWizard = new QWizard(this);
	QList<QWizard::WizardButton> layout;
	layout << QWizard::Stretch << QWizard::NextButton << QWizard::CancelButton << QWizard::FinishButton;
	maWizard->setButtonLayout(layout);
	
	maWizard->addPage(maOrientationPage("Z-axis upwards", "Z-axis facing UPWARDS. "));
	maWizard->addPage(maOrientationPage("Z-axis down", "Z-axis facing DOWNARDS. "));	

	maWizard->addPage(maOrientationPage("X-axis up", "X-axis facing UPWARDS. "));	
	maWizard->addPage(maOrientationPage("X-axis down", "X-axis facing DOWNARDS. "));

	maWizard->addPage(maOrientationPage("Y-axis up", "Y-axis facing UPWARDS. "));
	maWizard->addPage(maOrientationPage("Y-axis down", "Y-axis facing DOWNARDS. "));
	
	maWizard->addPage(maFinishedPage());
	
	maWizard->setWindowTitle("LPMS Misalignment Calibration Wizard");
	maWizard->show();
		
	connect(maWizard, SIGNAL(currentIdChanged(int)), this, SLOT(maNewPage(int)));
	connect(maWizard, SIGNAL(finished(int)), this, SLOT(maFinished(int)));
	
	currentLpms->getSensor()->initMisalignCal();
	
	maCalibrationFinished = false;
	maIsCalibrating = true;
}

void MainWindow::maNewPage(int i)
{
	switch (i) {
	case 1:
		currentLpms->getSensor()->startGetMisalign(0);
		startWaitBar(5);
	break;
	
	case 2:
		currentLpms->getSensor()->startGetMisalign(1);
		startWaitBar(5);
	break;

	case 3:
		currentLpms->getSensor()->startGetMisalign(2);
		startWaitBar(5);
	break;
	
	case 4:
		currentLpms->getSensor()->startGetMisalign(3);
		startWaitBar(5);
	break;
	
	case 5:
		currentLpms->getSensor()->startGetMisalign(4);
		startWaitBar(5);
	break;
	
	case 6:
		currentLpms->getSensor()->startGetMisalign(5);
		maCalibrationFinished = true;
		startWaitBar(5);
	break;
	}
}

void MainWindow::maFinished(int i)
{
	if (maCalibrationFinished == true) {
		currentLpms->getSensor()->calcMisalignMatrix();
	}
	
	maIsCalibrating = false;
}

void MainWindow::startWaitBar(int t)
{
	if (maIsCalibrating == true) {
		maWizard->hide();
	}

	calProgress = new QProgressDialog("Calibrating LPMS. Please wait..", QString() /*"Cancel"*/, 0, t, this);
    calProgress->setWindowModality(Qt::WindowModal);
	calProgress->setMinimumWidth(400);
	calProgress->setAutoReset(false);
	calProgress->show();

	calTimer = new QTimer(this);
	connect(calTimer, SIGNAL(timeout()), this, SLOT(calTimerUpdate()));
    calTimer->start(500);

	calMaxTime = t;
	calTime = 0;
}

void MainWindow::calTimerUpdate(void)
{
	++calTime;

	if (calTime > calMaxTime) {
		delete calProgress;
		delete calTimer;

		if (maIsCalibrating == true) {
			maWizard->show();
		}
	} else {
		calProgress->setValue(calTime);
	}
}

void MainWindow::addRemoveDevices(void)
{
	RescanDialog* rd = new RescanDialog(sm, deviceTree, this);
	rd->show();
}

void MainWindow::saveCalibrationData(void)
{
	if (currentLpms == 0 || isConnecting == true) return;
	
	QString qfn = QFileDialog::getOpenFileName(this, "Load calibration data", "./", "");
	string fn = qfn.toStdString();
		
	if (!(fn == "")) {		
		currentLpms->getSensor()->loadCalibrationData(fn);
	}	
}

void MainWindow::loadCalibrationData(void)
{
	if (currentLpms == 0 || isConnecting == true) return;
	
	QString qfn = QFileDialog::getSaveFileName(this, "Save calibration data", "./", "");
	string fn = qfn.toStdString();
		
	if (!(fn == "")) {		
		currentLpms->getSensor()->saveCalibrationData(fn);
	}	
}