/****************************************************************************
**
** Copyright (C) 2011 LP-Research
** All rights reserved.
** Contact: LP-Research (klaus@lp-research.com)
**
** This file is part of the Open Motion Analysis Toolkit (OpenMAT).
**
** OpenMAT is free software: you can redistribute it and/or modify it under 
** the terms of the GNU General Public License as published by the Free 
** Software Foundation, either version 3 of the License, or (at your option) 
** any later version.
** 
** OpenMAT is distributed in the hope that it will be useful, but WITHOUT 
** ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
** FITNESS FOR A PARTICULAR PURPOSE. See the GNU \ General Public License 
** for more details.
** 
** You should have received a copy of the GNU General Public License along 
** with the OpenMAT library. If not, see <http://www.gnu.org/licenses/>.
**
****************************************************************************/

#ifndef SAVE_DATA_THREAD
#define SAVE_DATA_THREAD

#include <QThread>

#include <string>
#include <iostream>
#include <fstream>
#include <queue>

#include <limits.h>

#include <boost/thread/thread.hpp> 

#include "ImuData.h"
#include "MicroMeasure.h"
#include "LpmsSensorI.h"

#define DATA_SAVE_PERIOD 1000

using namespace std;

/*!
	\brief	Provides functions to save the data sampled from the 
			connected IMUs.
*/
class SaveDataThread
{	
public:
	SaveDataThread(void);
	~SaveDataThread(void);
	bool startSaveImuData(string fn);
	void stopSaveImuData(void);
	void threadRun(void);
	void writeImuData(void);
	bool isRecording(void);
	void addSensor(LpmsSensorI* sensor);
	void removeSensor(LpmsSensorI* sensor);
	void writeImuData(ImuData d);
	long getStreamFrequency(LpmsSensorI *s);
	
public:
	ofstream imuDataStream;	
	bool saveImuStarted;
	list<LpmsSensorI*> sensorList;
};

#endif